<?php

namespace App\Controller;

use App\Container;
use App\Router\Request\IRequest;
use App\Router\Response\Response;
use Shared\Attributes\Route;
use Twig\Environment;
use Data\Core\Preferences;
use Shared\Log;

// TODO : Remove this BaseClass
class Controller extends BaseController
{
    private Environment $twig;
    private Preferences $preference;

    public function __construct()
    {
       session_start();
       $this->preference = new Preferences();
       setcookie('toto', 'wallah connard', time()+3600);
    }

    #[Route(path: '/', name: 'home', methods: ['GET'])] // 8
    public function index(): Response
    {
        return $this->render('./page/settings.html.twig',[
            'css' => $this->preference->getCookie(),
            'cook' => "home",
            'css' => 'pink_theme',
            'pp' => "test2",
            'user' => "Ladmion le Cochon",
            'role' => "Athlète",
            'friendship' => [],
            'analyzes' => [],
            'mails' => [],
            'users' => [],
            'infoUser' => [],
            'exos' => [],
            'member' => []
        ]);
    }

    #[Route(path: '/exercice', name: 'exercice', methods: ['GET'])] // 8
    public function exercice(): Response
    {
        return $this->render('./page/exercice.html.twig',[
            'css' => $preference.getCookie(),
            'pp' => "test2",
            'user' => "Ladmion le Cochon",
            'role' => "Athlète",
            'friendship' => [],
            'analyzes' => [],
            'mails' => [],
            'users' => [],
            'infoUser' => [],
            'exos' => [],
            'member' => []
        ]);
    }

    #[Route(path: '/friend', name: 'friend', methods: ['GET'])] // 8
    public function friend(): Response
    {
        return $this->render('./page/friend.html.twig',[
            'css' => $preference.getCookie(),
            'pp' => "test2",
            'user' => "Ladmion le Cochon",
            'role' => "Athlète",
            'friendship' => [],
            'analyzes' => [],
            'mails' => [],
            'users' => [],
            'infoUser' => [],
            'exos' => [],
            'member' => []
        ]);
    }

    #[Route(path: '/coaching', name: 'coaching', methods: ['GET'])] // 8
    public function coaching(): Response
    {
        return $this->render('./page/coaching.html.twig',[
            'css' => $preference.getCookie(),
            'pp' => "test2",
            'user' => "Ladmion le Cochon",
            'role' => "Athlète",
            'friendship' => [],
            'analyzes' => [],
            'mails' => [],
            'users' => [],
            'infoUser' => [],
            'exos' => [],
            'member' => []
        ]);
    }

    #[Route(path: '/mail', name: 'mail', methods: ['GET'])] // 8
    public function mail(): Response
    {
        return $this->render('./page/mail.html.twig',[
            'css' => $preference.getCookie(),
            'pp' => "test2",
            'user' => "Ladmion le Cochon",
            'role' => "Athlète",
            'friendship' => [],
            'analyzes' => [],
            'mails' => [],
            'users' => [],
            'infoUser' => [],
            'exos' => [],
            'member' => []
        ]);
    }

    #[Route(path: '/import', name: 'import', methods: ['GET'])] // 8
    public function import(): Response
    {
        return $this->render('./page/import.html.twig',[
            'css' => $preference.getCookie(),
            'pp' => "test2",
            'user' => "Ladmion le Cochon",
            'role' => "Athlète",
            'friendship' => [],
            'analyzes' => [],
            'mails' => [],
            'users' => [],
            'infoUser' => [],
            'exos' => [],
            'member' => []
        ]);
    }

    #[Route(path: '/hello', name: 'hello', methods: ['GET'])]
    public function hello(): Response
    {
        return new Response('Hello');
    }

    #[Route(path: '/', name: 'preferences', methods: ['POST'])]
    public function preferences(string $theme, IRequest $req): Response
    {
        /*TODO*/

        // FAUT VALIDER LES DONNEES BATARD

        $this->preference->majCookie($theme);
        // throw new \Exception("connard");
        // return new Response("");
        return $this->render('./page/settings.html.twig',[
            'css' => $this->preference->getCookie(),
            'cook' => $_COOKIE['preferences'] ?? "salopard",
            'css' => $this->preference->getCookie(),
            'pp' => "test2",
            'user' => "Ladmion le Cochon",
            'role' => "Athlète",
            'friendship' => [],
            'analyzes' => [],
            'mails' => [],
            'users' => [],
            'infoUser' => [],
            'exos' => [],
            'member' => []
        ]);
    }

}



